# Learning by Example: Conditional Rendering in React

This documentation is a continuation of [Lesson 201.2](/modules/201/2012).

<br />
---

## 1. Find these lines:
In `/ppbl-2023-front-end-starter/src/pages/index.tsx`:

```tsx
<Box w={{ base: "100%", md: "90%", lg: "70%" }} mx="auto" my="5" p="5" border="1px" borderRadius="md">
    <Heading size="md" pb="3">
        Lesson 201.3: Customize this component
    </Heading>
    <ContributorComponent />
</Box>
```

We can see a Component called `<ContributorComponent>`. Where did it come from?

<br />
---

## 2. Review Imports:
Remember that there are import statements at the top of the file:
```tsx
import Head from "next/head";
import { Box, Divider, Link as CLink, Heading, Text, UnorderedList, ListItem } from "@chakra-ui/react";
import { ContributorComponent } from "@/src/components/ContributorComponent";
import { QueryComponent } from "@/src/components/QueryComponent";
import { CardanoWallet } from "@meshsdk/react";
```

Do you see `ContributorComponent`? It is imported from `@/src/components`, which is a directory in the PPBL 2023 Front End Starter project. If we can find this file, we'll be able to change it!

<br />
---

## 3. Open ContributorComponent
Full path: `/ppbl-2023-front-end-starter/src/components/ContributorComponent`

It looks like this:
```tsx
import { Box, Text } from "@chakra-ui/react";
import { CardanoWallet } from "@meshsdk/react";

export const ContributorComponent = () => {
  return (
    <Box bg="theme.light" color="theme.dark" p="3">
        <Text>Hello I am a new component. Find me in /src/components</Text>
    </Box>
  );
};
```

### Try this:
- Change the text on Line 7.
- Save your changes.
- Look at localhost:3000. Can you see the changes?


<br />
---

## 4. Use Mesh to make a dynamic component:
We will check whether the connected wallet holds a PPBL 2023 Contributor token.

In this component, we do not need `CardanoWallet`, so you can replace it.


Change this import statement:
```tsx
import { CardanoWallet } from "@meshsdk/react";
```

To this:

```tsx
import { useAssets, useWallet } from "@meshsdk/react";
```

`useAssets` and `useWallet` are called [Hooks](https://react.dev/reference/react) - here is how to use them:

We can initialize the hooks like this:
```tsx
import { Box, Text } from "@chakra-ui/react";
import { useAssets, useWallet } from "@meshsdk/react";

export const ContributorComponent = () => {
  const { connected } = useWallet();
  const walletAssets = useAssets();

  return (
    <Box bg="theme.light" color="theme.dark" p="3">
        <Text>Hello I am a new component. Find me in /src/components</Text>
    </Box>
  );
};
```

Now, we can change the UI if a wallet is connected, by using `connected`, which returns `true` if a wallet is connected and `false` if it is not:
```tsx
export const ContributorComponent = () => {
  const { connected } = useWallet();
  const walletAssets = useAssets();

  return (
    <Box bg="theme.light" color="theme.dark" p="3">
        <Text>Hello I am a new component. Find me in /src/components</Text>
        {connected ? ("A wallet is connected!") : ("No wallet is connected!")}
    </Box>
  );
};
```

### Take a look in your browser. Try to connect and disconnect your wallet!

<br />
---

## 5. Get a list of tokens in connected wallet with `useAssets()`.

Now try this:
```tsx
export const ContributorComponent = () => {
  const { connected } = useWallet();
  const walletAssets = useAssets();

  return (
    <Box bg="theme.light" color="theme.dark" p="3">
        <Text>Hello I am a new component. Find me in /src/components</Text>
        {connected ? ("A wallet is connected!") : ("No wallet is connected!")}
        <pre>{JSON.stringify(walletAssets, null, 2)}</pre>
    </Box>
  );
};
```

### And check your browser again.
That's some raw data! It's probably not as "user-friendly" as we'd like to be, but we can use this data and make our page dance.


<br />
---

## 6. Let's find the PPBL 2023 token in that list of assets

Change your code to match this:

```tsx
import { Box, Text } from "@chakra-ui/react";
import { useAssets, useWallet } from "@meshsdk/react";
import { Asset } from "@meshsdk/core";
import { useEffect, useState } from "react";

export const ContributorComponent = () => {
  const { connected } = useWallet();
  const walletAssets = useAssets();

  const [connectedPPBL2023Token, setConnectedPPBL2023Token] = useState<Asset | undefined>(undefined);

  useEffect(() => {
    if (walletAssets) {
      const _ppbl2023 = walletAssets.filter(
        (a: Asset) => a.unit.substring(0, 56) == "05cf1f9c1e4cdcb6702ed2c978d55beff5e178b206b4ec7935d5e056"
      );
      setConnectedPPBL2023Token(_ppbl2023[0]);
    }
  }, [walletAssets]);


  return (
    <Box bg="theme.light" color="theme.dark" p="3">
        <Text>Hello I am a new component. Find me in /src/components</Text>
        {connectedPPBL2023Token ? (
          <Box bg="green.400" m="2" p="2">You have the token</Box>
        ) : (
          <Box bg="red.400" m="2" p="2">You do not have the token</Box>
        )}
    </Box>
  );
};
```

### At Live Coding on 2023-04-12, we will take a close look at this example.

- What is new to you? Make sure to bring your questions.
- To experiment with this code, what do you want to change?

<br />
---

## Keep Learning
- [React Tutorial](https://react.dev/learn/tutorial-tic-tac-toe)


import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;